using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Remoting.Channels.Http;
using ChatLib;
using System.Runtime.Serialization.Formatters;

namespace ChatApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //¼
        private ChatLib.ChatEventRepeater repeater = new ChatLib.ChatEventRepeater();
        //ıؽӿڣProxy
        private ChatLib.IChatReceiver chatServer;
        
        private void Form1_Load(object sender, EventArgs e)
        {
            // ͨ÷еļ
            BinaryServerFormatterSinkProvider provider = new BinaryServerFormatterSinkProvider();
            provider.TypeFilterLevel = TypeFilterLevel.Full;
            // ͨ
            IDictionary props = new Hashtable();
            props["port"] = 0;
            //עTCPͨԼ˵ķ
            TcpChannel chn = new TcpChannel(props, null, provider);
            ChannelServices.RegisterChannel(chn);

            repeater.ReceiveMessage += new ChatLib.MessageReceiveHandler(repeater_ReceiveMessage);
            try
            {
                //ԼChatServerԼϢ
                RemotingConfiguration.Configure("ChatServer.config");
                //ʾԼΪ
                this.Text = "Remoting ";
            }
            catch
            {
                //ԼChatServerʧܣֻΪӻ
                this.Text = "Remoting ӻ";
            }
        }
        //¼ַ¼ʱִ
        void repeater_ReceiveMessage(object sender, ReceiveMessageEventArgs e)
        {
            //ת߳
            if (this.InvokeRequired)
            {
                ChatLib.MessageReceiveHandler handler = new MessageReceiveHandler(RefreshHistory);
                Invoke(handler, sender, e);
            }
        }

        //ʾյϢ
        private void RefreshHistory(object sender, ReceiveMessageEventArgs e)
        {
            txtHistory.Text += e.Message+Environment.NewLine;
        }



        private void btnConnect_Click(object sender, EventArgs e)
        {
            //÷Զ̶ıش
            chatServer = (ChatLib.IChatReceiver)Activator.GetObject(
                 typeof(ChatLib.IChatReceiver),
                 "tcp://" + this.txtServer.Text + ":" + this.txtPort.Text + "/ChatServer.rem"
                 );
            //ص¼ӵб
            chatServer.AddEventRepeater(repeater);

            Text += "";

        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            //Ϣ
            chatServer.Send(txtNickname.Text + "˵" + txtMessage.Text);
        }


    }
}