using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace ChatLib
{
    public class ChatServer : System.MarshalByRefObject,IChatReceiver
    {
        /// <summary>
        /// Ϣ¼
        /// </summary>
        public event MessageReceiveHandler ReceiveMessage;

        /// <summary>
        /// ̬ԱڱصĶʡ
        /// </summary>
        private static ChatEventRepeaters repeaters;
        /// <summary>
        /// SingletonΨһʵģʽ
        /// </summary>
        public static ChatEventRepeaters Repeaters
        {
            get{
                if(repeaters==null)
                    repeaters = new ChatEventRepeaters();
                return repeaters;
            }
        }
        #region IChatReceiver Members
        /// <summary>
        /// ϢԱڷChatEventRepeaterĿͻ˽ܣԼ
        /// </summary>
        /// <param name="message"></param>
        public void Send(string message)
        {
            int iii = Repeaters.Count;
            Console.Write("Thread {0} ", System.Threading.Thread.CurrentThread.GetHashCode());
            Console.WriteLine("Repeaters Count is {0}", iii);
                //ͨReceiveMessageEventArgsͻ˷
                ReceiveMessageEventArgs e = new ReceiveMessageEventArgs();
                e.Message = message;
                try
                {
                    //ͻ˵Ϣ¼
                    OnReceiveMessage(e);
                }
                catch (Exception ex)
                {
                    //¼쳣Ϣδʵ֣
                    Console.Write("Thread {0} ", System.Threading.Thread.CurrentThread.GetHashCode());
                    Console.WriteLine(ex.Message);
                }
        }
        /// <summary>
        /// ͻڷԼChatEventRepeaterͿԼ
        /// </summary>
        /// <param name="repeater"></param>
        public void AddEventRepeater(ChatEventRepeater repeater)
        {
            //ڷͻ˵ChatEventRepeater
            Repeaters.Add(repeater);
            this.ReceiveMessage += new MessageReceiveHandler(repeater.OnReceiveMessage);
            Console.Write("Thread {0} ", System.Threading.Thread.CurrentThread.GetHashCode());
            Console.WriteLine("Add a EventRepeater:{0}, Total is {1}", repeater.GetHashCode(), Repeaters.Count);
        }
        void OnReceiveMessage(ReceiveMessageEventArgs e)
        {
            if (ReceiveMessage == null)
            { return; }
            ReceiveMessage(null, e);
        }
        #endregion
    }
}
